import { Platform } from "../platform";
import { CapabilityQuery } from "../capability-query";
import { ServiceProxy } from "../service-proxy";
import * as P from "bluebird";
import { ServiceRequest } from "../service-request";
export interface MessagingPlatformOptions {
    secure?: boolean;
    version?: number;
}
export declare class MessagingPlatformClient implements Platform {
    private host;
    private port;
    private options;
    constructor(host: string, port: number, options: MessagingPlatformOptions);
    resolveService(query: CapabilityQuery): P<ServiceProxy>;
    send(request: ServiceRequest): P<any>;
    exec(request: ServiceRequest): P<any>;
    broadcast(request: ServiceRequest): P<any>;
    head(request: ServiceRequest): P<any>;
}
