import { Platform } from "../platform";
import { CapabilityQuery } from "../capability-query";
import { ServiceProxy } from "../service-proxy";
import * as P from "bluebird";
import { ServiceRequest } from "../service-request";
export interface StreamPlatformOptions {
    secure?: boolean;
    version?: number;
}
export declare class StreamPlatformClient implements Platform {
    private host;
    private port;
    private options;
    private socket;
    private logger;
    private conn;
    private connResolver;
    private connRejecter;
    constructor(host: string, port: number, options: StreamPlatformOptions);
    initialize(): void;
    protected connection(): P<any>;
    resolveService(query: CapabilityQuery): P<ServiceProxy>;
    send(request: ServiceRequest): P<any>;
    exec(request: ServiceRequest): P<any>;
    broadcast(request: ServiceRequest): P<any>;
    head(request: ServiceRequest): P<any>;
}
