import * as P from "bluebird";
import { Platform } from "./platform";
export declare enum PlatformProtocols {
    HTTP = 0,
    STREAM = 1,
    MESSAGING = 2,
}
export interface PlatformLocatorOptions {
    protocol: PlatformProtocols;
    secure?: boolean;
    host?: string;
    port?: number;
    version: any;
}
export declare class PlatformLocator {
    /**
     * Primary platform facade. Connect will establish a connection to the platform and return
     * a platform instance to perform operations.
     *
     * @param cfg PlatformLocatorOptions instance
     *
     * @returns {Promise<Platform>|Promise}
     */
    static connect(cfg?: PlatformLocatorOptions): P<Platform>;
}
