import * as joi from "joi";
/**
 * Schema describes a data structure
 */
export declare class Schema {
    private id;
    private version;
    protected schema: joi.ObjectSchema;
    constructor(id?: any, version?: any);
    getId(): string;
    getUrn(): string;
    /**
     * Check if the provided object comply with this schema
     * @param object The object to validate
     * @return Promise resolved on the
     */
    validate(object: any): joi.ValidationResult<any>;
    /**
     * Configure the Joi object schema for this schema.
     * @param object
     * @returns {joi.ObjectSchema} The joi schema directly to add support for chaining syntax
     */
    keys(object: any): joi.ObjectSchema;
    /**
     * Transform this object into a complying schema instance.
     * @param object
     */
    normalize(object: any): joi.ValidationResult<any>;
    static Types: typeof joi;
}
